package;

import openfl.geom.*;
import terrylib.*;
import openfl.display.*;

class Main {
	
	private var tissue_count:Int=4;
	
	private var tissue_width:Int;
	private var tissue_height:Int;
	private var cutX:Int;
	private var cutY:Int;
	private var tissues:Array<BitmapData>;
	private var curTissue:Int = -1;
	
	private var t_x:Array<Int>;
	private var t_y:Array<Int>;
	
	//excludes max
	private function randRange(min:Int, max:Int):Int {
		return Math.floor(min + Math.random() * (max - min));
	}
	
	// This function is run when the program starts.
	public function new() {
		Gfx.addimage("background");
		Gfx.addimage("tissue");
		Gfx.addimage("tissueshadow");	
		
		tissue_width = Gfx.image_width("tissue");
		tissue_height = Gfx.image_height("tissue");
		
		t_x = new Array<Int>();
		t_y = new Array<Int>();
		for (i in 0...tissue_count) {
			//631, 136
			//631, 375
			t_x.push(480+20*(3-i));
			t_y.push(Math.round(270-(i+1)*(270-30)/tissue_count));
		}
		tissues = new Array<BitmapData>();
		for (i in 0...4*tissue_count) {
			var bmd:BitmapData = new BitmapData(tissue_width, tissue_height, true,0x00000000);
			//bmd.fillRect(new Rectangle(0, 0, 20, 20), 0xffff0000);
			tissues.push(bmd);
		}
		
		cutX = randRange(190, 400);
		cutY = randRange(150, 350);
	}
	
	private var shadowOffset:Int = 5;
	private var lastx = 0;
	private var lasty = 0;
	private var justDrag:Bool = false;
	
	private function SelectTissue(n:Int):Void {
		
		curTissue = n;	
		
		
		var tissues_new:Array<BitmapData> = new Array<BitmapData>();
		var t_x_new:Array<Int> = new Array<Int>();
		var t_y_new:Array<Int> = new Array<Int>();
		
		
		for ( i in 0...4) {
			if (i == n) {
				continue;
			}
			t_x_new.push(t_x[i]);
			t_y_new.push(t_y[i]);
				
			for ( j in 0...4) {
				tissues_new.push(tissues[4*i+j]);
			}
		}
		
		for ( j in 0...4) {
			tissues_new.push(tissues[4*n+j]);
		}
		t_x_new.push(t_x[n]);
		t_y_new.push(t_y[n]);
		
		t_x = t_x_new;
		t_y = t_y_new;
		tissues = tissues_new;
		curTissue = 3;
	}
	
	private var phase:Int;
	//This function is run 60 times a second.
	public function update():Void {		
		Gfx.drawimage(0, 0, "background");		
		
		var tissueOffsetX:Int = Math.floor(-tissue_width/2);
		var tissueOffsetY:Int = Math.floor( -tissue_height / 2);
		
		if (Mouse.leftpressed()) {		
			tissueOffsetX += shadowOffset;
			tissueOffsetY += shadowOffset;	
		}
		
		var tx:Int =  Mouse.x + tissueOffsetX;
		var ty:Int = Mouse.y + tissueOffsetY;
		
		if (Mouse.justleftpressed()) {
			phase = 0;
			lastx = Mouse.x;
			lasty = Mouse.y;
		}
		if (curTissue == -1) {
			if (Mouse.justleftpressed()) {
				var i:Int = tissue_count;
				while(i-->0) {
					var bmd = Gfx.getbmd("tissue");
					var dx:Int = Mouse.x - t_x[i];
					var dy:Int = Mouse.y - t_y[i];					
					var p:Int = bmd.getPixel32(dx,dy);
					if (p != 0) {
						SelectTissue(i);
						justDrag = true;
						break;
					}
				}
			}
		} else if (Mouse.leftpressed() && (Mouse.justleftpressed() || lastx!=Mouse.x || lasty!=Mouse.y))
		{
			if (Mouse.justleftpressed()) {
					justDrag = false;
			}
			if (Mouse.justleftpressed() && Gfx.getbmd("background").getPixel(Mouse.x, Mouse.y) == 0xA9BAC6) {
				curTissue = -1;
			} else if (justDrag==false) {
				var dx = cutX - tx;
				var dy = cutY - ty;
				
				var bmd = Gfx.getbmd("tissue");						
				var p:Int = bmd.getPixel32(dx,dy);
				if (p!=0){
					var s:Int = 2;
						
					for (j in 0...3) {
						var rx:Int = randRange(0, 2);
						var ry:Int = randRange(0, 2);
						if (Mouse.justleftpressed()){
							var s2 : Int = 1;
							tissues[curTissue*4+2].fillRect(new Rectangle(dx - 2 * s + rx * s, dy - 2 * s + ry * s, 5 * s, 5 * s), 0xffD82520);
						} else {
							var s2 : Int = 1;
							tissues[curTissue*4+2].fillRect(new Rectangle(dx - 1 * s2 + rx * s2, dy - 1 * s2 + ry * s2, 3 * s2, 3 * s2), 0xffD82520);				
						} 
					}
					
					
					if (Mouse.justleftpressed()){
						for (j in 0...3) {
							var rx:Int = randRange(0, 4);
							var ry:Int = randRange(0, 4);
							tissues[curTissue*4+1].fillRect(new Rectangle(dx - 3*s+rx*s, dy - 3*s+ry*s, 7*s, 7*s), 0xffD69B8B);
						}
						
						for (j in 0...3) {
							var rx:Int = randRange(0, 6);
							var ry:Int = randRange(0, 6);
							tissues[curTissue*4+1].fillRect(new Rectangle(dx - 4*s+rx*s, dy - 4*s+ry*s, 9*s, 9*s), 0xffD69B8B);
						}
					}		
				} else {
					
				}
			}
			phase = 0;
		} else  if (Mouse.leftpressed() && !Mouse.justleftpressed() && (lastx == Mouse.x && lasty == Mouse.y)) {
			phase++;
			trace(phase);
			var dx = cutX - tx;
			var dy = cutY - ty;
			var s:Int = Math.floor(Math.min(phase/20,5));
			tissues[curTissue*4+0].fillRect(new Rectangle(dx - 2 * s , dy - 2 * s, 5 * s, 5 * s), 0xffe6AB9B);
		} else {
			phase = 0;
		}
			
		if (curTissue >= 0) {
				t_x[curTissue] = tx;
				t_y[curTissue] = ty;
		}
		
		for (i in 0...tissue_count) {
			var ctx:Int = t_x[i];
			var cty:Int = t_y[i];
			shadowOffset = (i==curTissue&&Mouse.leftpressed()&&justDrag==false)?0:5;
			Gfx.drawimage(ctx+shadowOffset,cty+shadowOffset, "tissueshadow");					
			Gfx.drawimage(ctx, cty, "tissue");
			for (j in 0...4) {
				Gfx.drawbmd(ctx,cty,tissues[4*i+j]);					
			}
		}
		
		
		//Gfx.drawbox(cutX - 1, cutY - 1, 3, 3, 0xff0000);
		
		lastx = Mouse.x;
		lasty = Mouse.y;
	
	}
}